/*
 *	tm8.c - 8rbgvO}u^C}
 *
 *	* Tue Jan 15 21:43:00 JST 2002 Naoyuki Sawa
 *	- 1st release.
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "s1c33io.h"

/* 8rbg^C}̗pr(BIOS1.14)
 * Ch.	S1C33					o		Œ჌[g	P/ECE
 * 0	DRAMtbVAA/DϊJngK			366Hz		gp
 * 1	OSC3̔M҂					 23Hz		<-(X^oC)
 * 2	VACh.0ւ̃NbN				 23Hz		gp(USB]̌`Ղ)
 * 3	VACh.1ւ̃NbN				366Hz		gp
 * 4	VACh.2ւ̃NbN		s	s	 23Hz		gp
 * 5	VACh.3ւ̃NbN		s	s	366Hz		<-(LCD])
 */

char vbuff[DISP_X * DISP_Y];	/* zVRAM */
volatile int timer;		/* ^C}荞݂ŁAJEgAbv */

#define TM80_TRAP	52	/* 8rbg^C}Ch.0̊荞ݔԍ */

/****************************************************************************
 *	tm80_isr
 ****************************************************************************/

/* INT_END2reti邽߂ɁAڂISRł̓[Jϐg܂B
 * ̂߁A[JϐȂ̊֐𒆌pāAISR{̂Ăяo܂B
 */
static void _tm80_isr();
static void tm80_isr() { INT_BEGIN2; _tm80_isr(); INT_END2; }

static void
_tm80_isr()
{
	char ch;

	/* BIOŚAȂ荞ݗvtÔ݁AZbgI[łȂR/W̗pĂ܂B
	 * R/Wł́AoCgɊ蓖Ăꂽʂ̃tOZbgĂ܂ꂪ܂B
	 * ۂɂ́A8rbg^C}荞݂͑Sċ󂫂Ȃ̂ŁAԈĕʂ̃`lNA邱Ƃ͂肦܂񂪁A
	 * Ô߁AꎞIɃZbgI[ɕύXA荞ݗvtONAAɖ߂Ƃɂ܂B
	 */
	ch = inb(RSTONLY);	/* Zbgޔ */
	outb(RSTONLY, ch | 1);	/* ꎞIɃZbgI[ɕύX */
	outb(F8TU0, 1);		/* `l0̊荞ݗvtONA */
	outb(RSTONLY, ch);	/* Zbg𕜌 */

	/* ^C}JEgAbvB */
	timer++;
}

/****************************************************************************
 *	tm80_isr
 ****************************************************************************/

void
pceAppInit()
{
	char ch;

	/* ʏ̏B */
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	DISABLE;

	/* 荞݃nhݒ */
	pceVectorSetTrap(TM80_TRAP, tm80_isr);

	/* 荞݃x := 1 (0ȊOȂ牽łOK) */
	ch = inb(P8TM0);
	ch &= 0xF0;
	ch |= 1;
	outb(P8TM0, ch);

	/* NbN := /256 (=24MHz) */
	ch = inb(P8TPCK0);	/* NbNgp */
	ch &= ~1;
	outb(P8TPCK0, ch);
	ch = inb(P8TON0);	/* /256AX^[g */
	ch &= 0xF0;
	ch |= 0x0F;
	outb(P8TON0, ch);

	/* 荞ݎ := NbN/(255+1) */
	outb(RLD00, 255);

	/* [hE^C}Jn */
	outb(PTRUN0, 3);

	/* 荞݋ */
	ch = inb(E8TU0);
	ch |= 1;
	outb(E8TU0, ch);

	ENABLE;
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
	char ch;

	DISABLE;

	/* 荞݋֎~B */
	ch = inb(E8TU0);
	ch &= ~1;
	outb(E8TU0, ch);

	/* ^C}~ */
	outb(PTRUN0, 0);

	/* vXP[~ */
	ch = inb(P8TON0);
	ch &= 0xF0;
	outb(P8TON0, ch);

	ENABLE;
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	/* 100ڂ܂ŁAʍXV܂B */
	if(count <= 100) {
		/* pceAppProcĂ΂ꂽ񐔂ƁA^C}̒l\܂B */
		memset(vbuff, 0, sizeof vbuff);
		pceFontSetType(0x80);
		pceFontSetPos(20, 30);
		pceFontPrintf("Ă΂ꂽ: %4d", count);
		pceFontSetPos(20, 40);
		pceFontPrintf("荞݉: %4d", timer);
		pceLCDTrans();
	}

	/* 110Ă΂ꂽAI܂B */
	if(count == 110) pceAppReqExit(0);
}
